function[bnets, effects, reward] = bn2_a(n)
% bn2_a - sets up an assembly line with n machines and n repair actions

% N = total number of variables
N = 2*n;

% bnets is a cell array
%bnets = cell(1,n+1);

% We define effects to be a cell array for convenience (may change)
effects = cell(1,n+1);

% Define the cpds for the first (default) bnet
bnet.cpt = cell(1,n);

% The dag structure is the same for each action
dag=zeros(N,N);
for i=1:n
  dag(i, i+n) = 1;
end;

for i=1:(n-1)
  dag(i, i+n+1) = 1;
end;

bnet.dag = dag;
bnet.ns = 2*ones(1,N);

cpt{1} = zeros(2,2);
cpt{1}(:) = [0.98 0.02 0.02 0.98];
for i=n+2:N
   cpt{i-n} = zeros(2,2,2);
   cpt{i-n}(:) = [0.98 0.7 0.7 0.02 0.02 0.3 0.3 0.98];
end

reward(1).domain = [N];
reward(1).values = zeros(2,1);
reward(1).values(:) = [0.0 1.0];

bnet.cpts = cpt;
bnets(1) = bnet;
effects{1} = [];

for j=2:n+1

  
  bnet.cpt{1} = zeros(2,2);
  if j==2,
    cpt{1}(:) = [0.0 0.0 1.0 1.0];
  else
    cpt{1} = bnets(1).cpts{1};
  end;

  for i=n+2:N
     cpt{i-n} = zeros(2,2,2);
     if i-n == j-1,
       cpt{i-n}(:) = [0.7 0.0 0.7 0.0 0.3 1.0 0.3 1.0];
     else
       cpt{i-n} = bnets(1).cpts{i-n};
     end;
  end
  bnet.cpts = cpt;
  bnets(j) = bnet;
  effects{j} = [j-1];
end;



