function[q] = bonus(bnets, r, basis, w)
%
%
% Note:  We don't multiply by a discount or add a reward here b/c we
%        are using a state-reward model.  Adding rewards shift each
%        Q function by a constant factor.  Multiplying by a discount
%        scales each Q function by a constant factor.

n = length(bnets);
q = cell(1:n);

% Note:  No point in multiplying by the discount here or below
%        since it is a constant factor

% q(1) = default by convention

q{1} = bprojw(bnets(1), basis, w);

for i=2:n
  q{i} = bprojw(bnets(i), basis, w);
  q{i} = condense_basis(subtract_bases(q{i},q{1}));
end;

