function[pv] = bproj(bnet, b)
% BPROJ - Product of transition matrix (bnet) with basis function
%         Returns another set of basis functions

[n,ns] = bnstats(bnet);

for k = 1:length(b)
  pv(k).domain = []; % Initialize domains

  % Add in parent sets one at a time

  for i=1:length(b(k).domain)  
    pv(k).domain = myunion(pv(k).domain, parents(bnet.dag, b(k).domain(i)));
  end

  % By convention, domain lists are sorted

  pv(k).domain = sort(pv(k).domain);
  b_sizes = ns(b(k).domain);
  domain_sizes = ns(pv(k).domain);

%  length(domain_sizes)
  pv(k).values = 0;
  if pv(k).domain     % Check for the null domain case
    if length(domain_sizes) == 1
	  pv(k).values = zeros(1,domain_sizes);
	else
	  pv(k).values = zeros(domain_sizes);
	end;
  end;

%   pv(k).values
   
  % Here we iterate over all combinations of the variables in the new,
  % backprojected domain, and ask what is the expected value of the next
  % state, as if the basis function were entire value function

  for i=1:prod(domain_sizes)
    pv(k).values(i) = 0;
    fromvals = ind2subv(domain_sizes, i);
    for j=1:prod(b_sizes)
      tovals = ind2subv(b_sizes, j);
      pv(k).values(i) = pv(k).values(i) + ...
           partial_transprob(bnet, pv(k).domain, fromvals, b(k).domain, tovals) * b(k).values(j);
    end;
  end;

  pv(k).domain = pv(k).domain+n;
end;



	
