function[p, normalize] = partial_transprob(bn, from, fromvals, to, tovals)		
% TRANSPROB computes transition probability from from to to

[n, ns] = bnstats(bn);
dag = bn.dag;

% Initialize the probability to 1.0
% Since this is a 2TBN, we can multiply the probs
% of each of the variables

p = 1.0;

if length(from) > 0   % Check for the null domain

% Copy over the fromvals into a single "evidence" array for the time t vars

  evidence = zeros(1,n);
  for i=1:length(fromvals)
	evidence(from(i)) = fromvals(i);
  end
  
  for i=1:length(tovals)
	var = to(i);
	par = parents(dag, var);
	index = mysub2ind(size(bn.cpts{var-n}), [evidence(par) tovals(i)]);
	p = p * bn.cpts{var-n}(index);
  end;
end;
