function[diff] = subtract_basis(b1, b2)
% SUBTRACT_BASIS subtracts basis function b2 from b1

% compute the new domain
[diff.domain, from1, from2] = union(b1.domain, b2.domain);

% figure out the new dimensions - icky
size1 = size(b1.values);
if size1(1) == 1
  size1 = size1(2:length(size1));
end;
size2 = size(b2.values);
if size2(1) == 1
  size2 = size2(2:length(size2));
end;
froms = [b1.domain(from1) b2.domain(from2)];
sizes = [size1(from1) size2(from2)];
[froms, remap] = sort(froms);
newsizes = sizes(remap);

% Handle the empty domain case.
if isempty(newsizes)
  newsizes = 1;
end;

% Handle 1d case

if size(newsizes) == 1
  newsizes = [1:newsizes];
end;

% compute subset indices
[i, sub1] = intersect(diff.domain,b1.domain);
[i, sub2] = intersect(diff.domain,b2.domain);

diff.values=zeros(newsizes);

for i=1:prod(newsizes)
  diff.values(i) = b1.values(indexofsubset(newsizes, i, sub1)) -  b2.values(indexofsubset(newsizes,i, sub2));
end;

